%define anolis_release 2
%bcond_without optional_test
%global modname PPIx-Regexp

Name:           perl-%{modname}
Version:        0.087
Release:        %{anolis_release}%{?dist}
Summary:        Represent a regular expression of some sort
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/%{modname}
Source0:        https://cpan.metacpan.org/authors/id/W/WY/WYANT/%{modname}-%{version}.tar.gz

BuildRequires: coreutils make perl-generators perl-interpreter
BuildRequires: perl(:VERSION) perl(Carp) perl(Config) perl(Encode)
BuildRequires: perl(Exporter) perl(ExtUtils::MakeMaker) perl(List::Util)
BuildRequires: perl(PPI::Document) perl(Scalar::Util) perl(Task::Weaken)
BuildRequires: perl(Test::More) perl(base) perl(charnames) perl(constant)
BuildRequires: perl(lib) perl(open) perl(strict) perl(warnings)

%if %{with optional_test}
BuildRequires:  perl(Time::HiRes)
%endif

Recommends:     perl(Encode)
Obsoletes:      perl-%{modname}-tests < %{EVR}

Requires:       perl(Exporter) perl(Task::Weaken)
Requires:       perl(PPI::Document) >= 1.117 perl(PPI::Dumper) >= 1.117

BuildArch:      noarch

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(PPI::Document\\)$
%global __requires_exclude %{__requires_exclude}|^perl\\(My::Module::
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(My::Module::

%description
This package parses regular expressions as they appear in Perl scripts,
generating a structure similar to the structure generated by PPI when it
parses a Perl script, and navigable in much the same way.

The PPIx::Regexp object is instantiated using either new() or
new_from_cache(). Either way, you must pass it a regular expression,
either as a string or as one of the three relevant PPI objects:
PPI::Token::StringLike::Regexp, PPI::Token::Regexp::Match, or
PPI::Token::Regexp::Substitute. In the case of new_from_cache(), only
one PPIx::Regexp object will be generated from a given PPI object;
subsequent calls with the same PPI object will return the same
PPIx::Regexp object.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{modname}-%{version}
chmod -x eg/*
perl -MConfig -i -p \
    -e 's{^#!/usr/(?:local/bin/|bin/env )perl\b}{$Config{startperl}}' \
    eg/*
for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!\s*perl}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
unset MAKING_MODULE_DISTRIBUTION
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}

%check
unset AUTHOR_TESTING PPIX_REGEXP_TOKENIZER_TRACE
make test

%files
%{perl_vendorlib}/*
%{_mandir}/man3/*
%license LICENSES

%files doc
%doc README Changes eg

%changelog
* Thu Apr 13 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 0.087-2
- Refactor the specfile and remove tests sub-package

* Mon Feb 06 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.087-1
- remove versioned MODULE_COMPAT_ requires
- update to version 0.087

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.085-2
- rebuild with perl 5.36.0

* Wed Apr 20 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.085-1
- init from upstream
